package com.xiesx.fastboot.core.token.handle;

import com.xiesx.fastboot.core.token.JwtHelper;
import com.xiesx.fastboot.core.token.cfg.TokenCfg;
import io.jsonwebtoken.Claims;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;

/**
 * @title CurrentToken.java
 * @description 当前token附带信息
 * @author Sixian.xie
 * @date 2020-7-21 22:37:08
 */
@Data
@Builder
@AllArgsConstructor
public class CurrentToken {

    private String userId;

    private String userName;

    private String nickName;

    public static CurrentToken getCurrentToken(String token){
        // 获取token
        Claims claims = JwtHelper.parser(token);
        CurrentToken currentToken = new CurrentToken(claims.getOrDefault(TokenCfg.USERID, "").toString(),
                claims.getOrDefault(TokenCfg.USERNAME, "").toString(),
                claims.getOrDefault(TokenCfg.NICKNAME, "").toString());
        return currentToken;
    }
}
